Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest/mkf.info
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest/mkf.info	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest/mkf.info	(revision 138)
@@ -3,54 +3,59 @@
 target_dep	all	RegisterFile_Multi_Banked_00.ngc
 target_dep	RegisterFile_Multi_Banked_00.ngc	RegisterFile_Multi_Banked_00.prj
-target_dep	RegisterFile_Multi_Banked_00.prj	RegisterFile_Multi_Banked_00_bank_Pack.vhdl RegisterFile_Multi_Banked_00_bank.vhdl RegisterFile_Multi_Banked_00_Pack.vhdl RegisterFile_Multi_Banked_00_select_12_ports_Pack.vhdl RegisterFile_Multi_Banked_00_select_12_ports.vhdl RegisterFile_Multi_Banked_00_select_6_ports_Pack.vhdl RegisterFile_Multi_Banked_00_select_6_ports.vhdl RegisterFile_Multi_Banked_00.vhdl
+target_dep	RegisterFile_Multi_Banked_00.prj	RegisterFile_Multi_Banked_00_bank_Pack.vhdl RegisterFile_Multi_Banked_00_bank.vhdl RegisterFile_Multi_Banked_00_Pack.vhdl RegisterFile_Multi_Banked_00_select_3_ports_Pack.vhdl RegisterFile_Multi_Banked_00_select_3_ports.vhdl RegisterFile_Multi_Banked_00.vhdl
 
 # RegisterFile_Multi_Banked_01
 target_dep	all	RegisterFile_Multi_Banked_01.ngc
 target_dep	RegisterFile_Multi_Banked_01.ngc	RegisterFile_Multi_Banked_01.prj
-target_dep	RegisterFile_Multi_Banked_01.prj	RegisterFile_Multi_Banked_01_bank_Pack.vhdl RegisterFile_Multi_Banked_01_bank.vhdl RegisterFile_Multi_Banked_01_Pack.vhdl RegisterFile_Multi_Banked_01_select_6_ports_Pack.vhdl RegisterFile_Multi_Banked_01_select_6_ports.vhdl RegisterFile_Multi_Banked_01.vhdl
+target_dep	RegisterFile_Multi_Banked_01.prj	RegisterFile_Multi_Banked_01_bank_Pack.vhdl RegisterFile_Multi_Banked_01_bank.vhdl RegisterFile_Multi_Banked_01_Pack.vhdl RegisterFile_Multi_Banked_01_select_3_ports_Pack.vhdl RegisterFile_Multi_Banked_01_select_3_ports.vhdl RegisterFile_Multi_Banked_01.vhdl
 
 # RegisterFile_Multi_Banked_02
 target_dep	all	RegisterFile_Multi_Banked_02.ngc
 target_dep	RegisterFile_Multi_Banked_02.ngc	RegisterFile_Multi_Banked_02.prj
-target_dep	RegisterFile_Multi_Banked_02.prj	RegisterFile_Multi_Banked_02_bank_Pack.vhdl RegisterFile_Multi_Banked_02_bank.vhdl RegisterFile_Multi_Banked_02_Pack.vhdl RegisterFile_Multi_Banked_02_select_1_ports_Pack.vhdl RegisterFile_Multi_Banked_02_select_1_ports.vhdl RegisterFile_Multi_Banked_02_select_2_ports_Pack.vhdl RegisterFile_Multi_Banked_02_select_2_ports.vhdl RegisterFile_Multi_Banked_02.vhdl
+target_dep	RegisterFile_Multi_Banked_02.prj	RegisterFile_Multi_Banked_02_bank_Pack.vhdl RegisterFile_Multi_Banked_02_bank.vhdl RegisterFile_Multi_Banked_02_Pack.vhdl RegisterFile_Multi_Banked_02_select_4_ports_Pack.vhdl RegisterFile_Multi_Banked_02_select_4_ports.vhdl RegisterFile_Multi_Banked_02.vhdl
 
 # RegisterFile_Multi_Banked_03
 target_dep	all	RegisterFile_Multi_Banked_03.ngc
 target_dep	RegisterFile_Multi_Banked_03.ngc	RegisterFile_Multi_Banked_03.prj
-target_dep	RegisterFile_Multi_Banked_03.prj	RegisterFile_Multi_Banked_03_bank_Pack.vhdl RegisterFile_Multi_Banked_03_bank.vhdl RegisterFile_Multi_Banked_03_Pack.vhdl RegisterFile_Multi_Banked_03_select_2_ports_Pack.vhdl RegisterFile_Multi_Banked_03_select_2_ports.vhdl RegisterFile_Multi_Banked_03.vhdl
+target_dep	RegisterFile_Multi_Banked_03.prj	RegisterFile_Multi_Banked_03_bank_Pack.vhdl RegisterFile_Multi_Banked_03_bank.vhdl RegisterFile_Multi_Banked_03_Pack.vhdl RegisterFile_Multi_Banked_03_select_4_ports_Pack.vhdl RegisterFile_Multi_Banked_03_select_4_ports.vhdl RegisterFile_Multi_Banked_03.vhdl
 
 # RegisterFile_Multi_Banked_04
 target_dep	all	RegisterFile_Multi_Banked_04.ngc
 target_dep	RegisterFile_Multi_Banked_04.ngc	RegisterFile_Multi_Banked_04.prj
-target_dep	RegisterFile_Multi_Banked_04.prj	RegisterFile_Multi_Banked_04_bank_Pack.vhdl RegisterFile_Multi_Banked_04_bank.vhdl RegisterFile_Multi_Banked_04_Pack.vhdl RegisterFile_Multi_Banked_04_select_1_ports_Pack.vhdl RegisterFile_Multi_Banked_04_select_1_ports.vhdl RegisterFile_Multi_Banked_04_select_2_ports_Pack.vhdl RegisterFile_Multi_Banked_04_select_2_ports.vhdl RegisterFile_Multi_Banked_04.vhdl
+target_dep	RegisterFile_Multi_Banked_04.prj	RegisterFile_Multi_Banked_04_bank_Pack.vhdl RegisterFile_Multi_Banked_04_bank.vhdl RegisterFile_Multi_Banked_04_Pack.vhdl RegisterFile_Multi_Banked_04_select_6_ports_Pack.vhdl RegisterFile_Multi_Banked_04_select_6_ports.vhdl RegisterFile_Multi_Banked_04.vhdl
 
 # RegisterFile_Multi_Banked_05
 target_dep	all	RegisterFile_Multi_Banked_05.ngc
 target_dep	RegisterFile_Multi_Banked_05.ngc	RegisterFile_Multi_Banked_05.prj
-target_dep	RegisterFile_Multi_Banked_05.prj	RegisterFile_Multi_Banked_05_bank_Pack.vhdl RegisterFile_Multi_Banked_05_bank.vhdl RegisterFile_Multi_Banked_05_Pack.vhdl RegisterFile_Multi_Banked_05_select_12_ports_Pack.vhdl RegisterFile_Multi_Banked_05_select_12_ports.vhdl RegisterFile_Multi_Banked_05_select_6_ports_Pack.vhdl RegisterFile_Multi_Banked_05_select_6_ports.vhdl RegisterFile_Multi_Banked_05.vhdl
+target_dep	RegisterFile_Multi_Banked_05.prj	RegisterFile_Multi_Banked_05_bank_Pack.vhdl RegisterFile_Multi_Banked_05_bank.vhdl RegisterFile_Multi_Banked_05_Pack.vhdl RegisterFile_Multi_Banked_05_select_2_ports_Pack.vhdl RegisterFile_Multi_Banked_05_select_2_ports.vhdl RegisterFile_Multi_Banked_05.vhdl
 
 # RegisterFile_Multi_Banked_06
 target_dep	all	RegisterFile_Multi_Banked_06.ngc
 target_dep	RegisterFile_Multi_Banked_06.ngc	RegisterFile_Multi_Banked_06.prj
-target_dep	RegisterFile_Multi_Banked_06.prj	RegisterFile_Multi_Banked_06_bank_Pack.vhdl RegisterFile_Multi_Banked_06_bank.vhdl RegisterFile_Multi_Banked_06_Pack.vhdl RegisterFile_Multi_Banked_06_select_3_ports_Pack.vhdl RegisterFile_Multi_Banked_06_select_3_ports.vhdl RegisterFile_Multi_Banked_06.vhdl
+target_dep	RegisterFile_Multi_Banked_06.prj	RegisterFile_Multi_Banked_06_bank_Pack.vhdl RegisterFile_Multi_Banked_06_bank.vhdl RegisterFile_Multi_Banked_06_Pack.vhdl RegisterFile_Multi_Banked_06_select_6_ports_Pack.vhdl RegisterFile_Multi_Banked_06_select_6_ports.vhdl RegisterFile_Multi_Banked_06.vhdl
 
 # RegisterFile_Multi_Banked_07
 target_dep	all	RegisterFile_Multi_Banked_07.ngc
 target_dep	RegisterFile_Multi_Banked_07.ngc	RegisterFile_Multi_Banked_07.prj
-target_dep	RegisterFile_Multi_Banked_07.prj	RegisterFile_Multi_Banked_07_bank_Pack.vhdl RegisterFile_Multi_Banked_07_bank.vhdl RegisterFile_Multi_Banked_07_Pack.vhdl RegisterFile_Multi_Banked_07_select_2_ports_Pack.vhdl RegisterFile_Multi_Banked_07_select_2_ports.vhdl RegisterFile_Multi_Banked_07.vhdl
+target_dep	RegisterFile_Multi_Banked_07.prj	RegisterFile_Multi_Banked_07_bank_Pack.vhdl RegisterFile_Multi_Banked_07_bank.vhdl RegisterFile_Multi_Banked_07_Pack.vhdl RegisterFile_Multi_Banked_07_select_1_ports_Pack.vhdl RegisterFile_Multi_Banked_07_select_1_ports.vhdl RegisterFile_Multi_Banked_07_select_2_ports_Pack.vhdl RegisterFile_Multi_Banked_07_select_2_ports.vhdl RegisterFile_Multi_Banked_07.vhdl
 
 # RegisterFile_Multi_Banked_08
 target_dep	all	RegisterFile_Multi_Banked_08.ngc
 target_dep	RegisterFile_Multi_Banked_08.ngc	RegisterFile_Multi_Banked_08.prj
-target_dep	RegisterFile_Multi_Banked_08.prj	RegisterFile_Multi_Banked_08_bank_Pack.vhdl RegisterFile_Multi_Banked_08_bank.vhdl RegisterFile_Multi_Banked_08_Pack.vhdl RegisterFile_Multi_Banked_08_select_1_ports_Pack.vhdl RegisterFile_Multi_Banked_08_select_1_ports.vhdl RegisterFile_Multi_Banked_08_select_2_ports_Pack.vhdl RegisterFile_Multi_Banked_08_select_2_ports.vhdl RegisterFile_Multi_Banked_08.vhdl
+target_dep	RegisterFile_Multi_Banked_08.prj	RegisterFile_Multi_Banked_08_bank_Pack.vhdl RegisterFile_Multi_Banked_08_bank.vhdl RegisterFile_Multi_Banked_08_Pack.vhdl RegisterFile_Multi_Banked_08_select_11_ports_Pack.vhdl RegisterFile_Multi_Banked_08_select_11_ports.vhdl RegisterFile_Multi_Banked_08_select_22_ports_Pack.vhdl RegisterFile_Multi_Banked_08_select_22_ports.vhdl RegisterFile_Multi_Banked_08.vhdl
 
 # RegisterFile_Multi_Banked_09
 target_dep	all	RegisterFile_Multi_Banked_09.ngc
 target_dep	RegisterFile_Multi_Banked_09.ngc	RegisterFile_Multi_Banked_09.prj
-target_dep	RegisterFile_Multi_Banked_09.prj	RegisterFile_Multi_Banked_09_bank_Pack.vhdl RegisterFile_Multi_Banked_09_bank.vhdl RegisterFile_Multi_Banked_09_Pack.vhdl RegisterFile_Multi_Banked_09_select_6_ports_Pack.vhdl RegisterFile_Multi_Banked_09_select_6_ports.vhdl RegisterFile_Multi_Banked_09.vhdl
+target_dep	RegisterFile_Multi_Banked_09.prj	RegisterFile_Multi_Banked_09_bank_Pack.vhdl RegisterFile_Multi_Banked_09_bank.vhdl RegisterFile_Multi_Banked_09_Pack.vhdl RegisterFile_Multi_Banked_09_select_2_ports_Pack.vhdl RegisterFile_Multi_Banked_09_select_2_ports.vhdl RegisterFile_Multi_Banked_09_select_3_ports_Pack.vhdl RegisterFile_Multi_Banked_09_select_3_ports.vhdl RegisterFile_Multi_Banked_09_select_4_ports_Pack.vhdl RegisterFile_Multi_Banked_09_select_4_ports.vhdl RegisterFile_Multi_Banked_09.vhdl
 
 # RegisterFile_Multi_Banked_10
 target_dep	all	RegisterFile_Multi_Banked_10.ngc
 target_dep	RegisterFile_Multi_Banked_10.ngc	RegisterFile_Multi_Banked_10.prj
-target_dep	RegisterFile_Multi_Banked_10.prj	RegisterFile_Multi_Banked_10_bank_Pack.vhdl RegisterFile_Multi_Banked_10_bank.vhdl RegisterFile_Multi_Banked_10_Pack.vhdl RegisterFile_Multi_Banked_10_select_3_ports_Pack.vhdl RegisterFile_Multi_Banked_10_select_3_ports.vhdl RegisterFile_Multi_Banked_10.vhdl
+target_dep	RegisterFile_Multi_Banked_10.prj	RegisterFile_Multi_Banked_10_bank_Pack.vhdl RegisterFile_Multi_Banked_10_bank.vhdl RegisterFile_Multi_Banked_10_Pack.vhdl RegisterFile_Multi_Banked_10_select_11_ports_Pack.vhdl RegisterFile_Multi_Banked_10_select_11_ports.vhdl RegisterFile_Multi_Banked_10.vhdl
 
+# RegisterFile_Multi_Banked_11
+target_dep	all	RegisterFile_Multi_Banked_11.ngc
+target_dep	RegisterFile_Multi_Banked_11.ngc	RegisterFile_Multi_Banked_11.prj
+target_dep	RegisterFile_Multi_Banked_11.prj	RegisterFile_Multi_Banked_11_bank_Pack.vhdl RegisterFile_Multi_Banked_11_bank.vhdl RegisterFile_Multi_Banked_11_Pack.vhdl RegisterFile_Multi_Banked_11_select_1_ports_Pack.vhdl RegisterFile_Multi_Banked_11_select_1_ports.vhdl RegisterFile_Multi_Banked_11_select_2_ports_Pack.vhdl RegisterFile_Multi_Banked_11_select_2_ports.vhdl RegisterFile_Multi_Banked_11.vhdl
+
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Common
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Common	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Common	(revision 138)
@@ -29,6 +29,6 @@
 DIR_INC				= include
 DIR_SRC				= src
-DIR_OBJ				= $(DIR_TMP)/obj
-DIR_LIB                         = $(MORPHEO_PREFIX)/lib
+DIR_OBJ				= $(DIR_TMP)/obj/$(MORPHEO_TYPE)
+DIR_LIB                         = $(MORPHEO_PREFIX)/lib/$(MORPHEO_TYPE)
 DIR_SCRIPT			= $(MORPHEO_SCRIPT)
 
@@ -49,17 +49,18 @@
 
 #-----[ Variable ]-----------------------------------------
+PREFIX_OBJ			= $(ENTITY)_
 #OBJECTS_COMMON			= $(patsubst $(DIR_SRC)/%.cpp,$(DIR_OBJ)/%.o,$(wildcard $(DIR_SRC)/*.cpp))
 SOURCES				= $(wildcard $(DIR_SRC)/*.cpp)
-OBJECTS_COMMON			= $(addprefix $(DIR_OBJ)/$(ENTITY)_, $(addsuffix .o, $(basename $(notdir $(SOURCES)))))
+OBJECTS_COMMON			= $(addprefix $(DIR_OBJ)/$(PREFIX_OBJ), $(addsuffix .o, $(basename $(notdir $(SOURCES)))))
 
 HEADERS  			= $(wildcard $(DIR_INC)/*.h)
 
 #-----[ Rules ]--------------------------------------------
-.PRECIOUS			: $(DIR_OBJ)/$(ENTITY)_%.o
+.PRECIOUS			: $(DIR_OBJ)/$(PREFIX_OBJ)%.o
 
 test_env			:
 				@$(ECHO) "-------------------| $(ENTITY)"
 
-$(DIR_OBJ)/$(ENTITY)_%.o        : $(DIR_SRC)/%.cpp $(HEADERS)
+$(DIR_OBJ)/$(PREFIX_OBJ)%.o	: $(DIR_SRC)/%.cpp $(HEADERS)
 				@\
 				$(ECHO) "Compilation        : $*";\
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.mkf
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.mkf	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.mkf	(revision 138)
@@ -6,22 +6,22 @@
 
 _Generic/Queue/SelfTest:
-	make all -C Generic/Queue/SelfTest
+	gmake all -C Generic/Queue/SelfTest
 
 _Generic/RegisterFile/RegisterFile_Monolithic/SelfTest:
-	make all -C Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
+	gmake all -C Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
 
 _Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest:
-	make all -C Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest
+	gmake all -C Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest
 
 clean:
-	make clean -C Generic/Queue/SelfTest
-	make clean -C Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
-	make clean -C Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest
+	gmake clean -C Generic/Queue/SelfTest
+	gmake clean -C Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
+	gmake clean -C Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest
 
 re: clean all
 
 install:
-	make install -C Generic/Queue/SelfTest
-	make install -C Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
-	make install -C Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest
+	gmake install -C Generic/Queue/SelfTest
+	gmake install -C Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
+	gmake install -C Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component.sh
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component.sh	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component.sh	(revision 138)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 SED_SCRIPT=".sed_script";
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component_vst/src/New_Component.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component_vst/src/New_Component.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component_vst/src/New_Component.cpp	(revision 138)
@@ -62,5 +62,5 @@
 #endif
 
-#ifdef SYSTEMC
+#if defined(SYSTEMC) and (defined(STATISTICS) or defined(VHDL_TESTBENCH))
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
@@ -74,7 +74,6 @@
 	// List dependency information
 # endif    
-	
+      }
 #endif
-      }
     log_end(@COMPONENT,FUNCTION);
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Signal.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Signal.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Signal.h	(revision 138)
@@ -143,4 +143,5 @@
 	}
     }
+#endif
 
 #undef  FUNCTION
@@ -184,5 +185,31 @@
       log_printf(FUNC,Behavioural,FUNCTION,"End");
     }
-#endif
+
+
+#undef  FUNCTION
+#define FUNCTION "Signal::alloc"
+  void              dealloc         (void)
+    {
+      log_printf(FUNC,Behavioural,FUNCTION,"Begin");
+
+      switch (_direction)
+        {
+        case INTERNAL :
+          switch (_type_info)
+            {
+            case BOOL     : delete (static_cast<sc_signal <bool    > *>(_sc_signal_map)); break; 
+            case UINT8_T  : delete (static_cast<sc_signal <uint8_t > *>(_sc_signal_map)); break; 
+            case UINT16_T : delete (static_cast<sc_signal <uint16_t> *>(_sc_signal_map)); break;
+            case UINT32_T : delete (static_cast<sc_signal <uint32_t> *>(_sc_signal_map)); break; 
+            case UINT64_T : delete (static_cast<sc_signal <uint64_t> *>(_sc_signal_map)); break; 
+            default       : throw (ErrorMorpheo ("Signal \""+_name+"\" : type unknow.\n"));
+            }
+        default : throw (ErrorMorpheo ("Signal \""+_name+"\" : invalid direction.\n"));
+
+
+        }
+
+      log_printf(FUNC,Behavioural,FUNCTION,"End");
+    }
 
 #ifdef VHDL
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Simulation.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Simulation.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Simulation.h	(revision 138)
@@ -19,8 +19,16 @@
 namespace behavioural          {
 
+  typedef enum
+    {
+      ALL_THREAD,
+      EACH_THREAD_AND_CONTINUE,
+      EACH_THREAD_AND_STOP
+    } stop_type_t;
+
   extern bool                _simulation_stop_exception;
   extern double              _simulation_nb_cycle;
   extern double              _simulation_nb_instruction;
   extern std::vector<double> _simulation_nb_instruction_commited;
+  extern stop_type_t         _simulation_stop_type;
   extern bool                _simulation_file_with_date;
   extern bool                _simulation_file_with_pid ;
@@ -29,10 +37,40 @@
 
   bool simulation_test_end (void);
-  void simulation_init     (double nb_cycle,
-                            double denug_nb_cycle,
-                            double nb_instruction,
-                            bool   file_with_date,
-                            bool   file_with_pid);
+  void simulation_init     (double      nb_cycle,
+                            double      denug_nb_cycle,
+                            double      nb_instruction,
+                            stop_type_t stop_type,
+                            bool        file_with_date,
+                            bool        file_with_pid);
 }; // end namespace behavioural          
+
+  template<> inline std::string toString<morpheo::behavioural::stop_type_t>(const morpheo::behavioural::stop_type_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::ALL_THREAD               : return "all_thread"; break;
+      case morpheo::behavioural::EACH_THREAD_AND_CONTINUE : return "each_thread_and_continue"; break;
+      case morpheo::behavioural::EACH_THREAD_AND_STOP     : return "each_thread_and_stop"; break;
+      default : return ""; break;
+      }
+  };
+
+  template<> inline morpheo::behavioural::stop_type_t fromString<morpheo::behavioural::stop_type_t>(const std::string& x)
+  {
+    if ((x.compare(toString(static_cast<uint32_t>(morpheo::behavioural::ALL_THREAD))) == 0) or
+        (x.compare(toString(                      morpheo::behavioural::ALL_THREAD )) == 0))
+      return morpheo::behavioural::ALL_THREAD;
+
+    if ((x.compare(toString(static_cast<uint32_t>(morpheo::behavioural::EACH_THREAD_AND_CONTINUE))) == 0) or
+        (x.compare(toString(                      morpheo::behavioural::EACH_THREAD_AND_CONTINUE )) == 0))
+      return morpheo::behavioural::EACH_THREAD_AND_CONTINUE;
+
+    if ((x.compare(toString(static_cast<uint32_t>(morpheo::behavioural::EACH_THREAD_AND_STOP))) == 0) or
+        (x.compare(toString(                      morpheo::behavioural::EACH_THREAD_AND_STOP )) == 0))
+      return morpheo::behavioural::EACH_THREAD_AND_STOP;
+
+    throw (ERRORMORPHEO ("fromString","Unknow string : \""+x+"\""));
+  };
+
 }; // end namespace morpheo              
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Stat.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Stat.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Stat.h	(revision 138)
@@ -49,14 +49,16 @@
     private: const cycle_t                  _period;
     private: const bool                     _save_periodic;
+    private: bool                           _generate_file;
+
       // Tableau des variables
     private: std::map<std::string, var_t> * _list_operand;
       // Liste chaîné des expressions
     private: std::list<expr_t>            * _list_expr;
+      // List chaîné des "counters" (seulement pour la désallocation)
+    private: std::list<counters_t*>       * _list_counters;
 
     private: counter_t                    * _cycle;
 
     private: std::list<Stat *>            * _list_stat;
-
-    private: bool                           _generate_file;
 
     public :                     Stat                         (std::string name_instance,
@@ -73,4 +75,10 @@
 						               std::string unit,
 						               std::string description);
+    public  : counters_t *       create_counters              (std::string varname,
+                                                               uint32_t    nb_counter,
+						               std::string unit,
+						               std::string description_counter, // need one %d
+                                                               std::string description_percent, // need one %d
+                                                               std::string description_average);
     private : counter_t *        alloc_operand                (counter_type_t type,
 						               std::string varname,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Stat_type.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Stat_type.h	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Stat_type.h	(revision 138)
@@ -6,4 +6,5 @@
 #include <map>
 #include <utility>
+#include <cassert>
 
 namespace morpheo {
@@ -19,4 +20,62 @@
 //typedef std::pair<std::string, operator_t> pair_string_operator_t;
 
+  class counters_t
+  {
+  private : const uint32_t     _nb_counter;
+  private :       counter_t ** _counter;
+
+  public  : counters_t (uint32_t nb_counter):
+    _nb_counter (nb_counter+1)
+    {
+      assert(nb_counter>0);
+
+      _counter = new counter_t * [_nb_counter];
+    }
+
+  // public : counters_t (const counters_t & x):
+  //   _nb_counter (x._nb_counter)
+  //   {
+  //     _counter = new counter_t [_nb_counter];
+      
+  //     for (uint32_t i=0; i<_nb_counter; ++i)
+  //       _counter[i] = x._counter[i];
+  //   }
+    
+  public  : ~counters_t (void)
+    {
+      delete [] _counter;
+    }
+
+  public  : void set_counter (counter_t * counter,
+                              uint32_t    index)
+    {
+      assert((index >= 0) and (index < _nb_counter));
+
+      _counter [index] = counter;
+    }
+
+  // public : friend const counters_t  operator+ (const counters_t & left,
+  //                                              const uint32_t     right)
+  //   {
+  //     assert((right >= 0) and (right <= left._nb_counter));
+      
+  //     counters_t tmp=left;
+      
+  //     tmp._counter[right] ++;
+    
+  //     return tmp;
+  //   }
+
+  public : const counters_t & operator+= (const uint32_t value)
+    {
+      assert((value >= 0) and (value <= _nb_counter));
+      
+      (*_counter[value]) ++;
+      
+      return *this;
+    }
+
+  };
+
 };
 };
